%define section free

Summary:        XSL-driven print formatter
Name:           fop
Version:        0.20.5
Release:        6jpp_1rh
Epoch:          0
License:        Apache Software License
Group:          Text Processing/Markup/XML
Source0:        http://www.apache.org/dist/xml/fop/fop-0.20.5-src.tar.gz
Source1:        %{name}.script
Patch0:         %{name}-javadoc-crosslink.patch
Patch1:         %{name}-build-manifest.patch
URL:            http://xml.apache.org/fop/
Requires:       avalon-logkit, batik >= 0:1.5, jpackage-utils >= 0:1.5
Requires:	    jaxp_parser_impl, jaxp_transform_impl, xml-commons-apis
BuildRequires:  ant >= 0:1.6, jpackage-utils >= 0:1.5, xalan-j2 >= 0:2.4.1, batik, jce
BuildRequires:  ant-trax >= 0:1.6, jaxp_transform_impl
BuildRequires:  avalon-logkit, java-javadoc, batik-javadoc, jimi
BuildRequires:  coreutils
# Not really required as it will fall back to jimi
#BuildRequires:  jai
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
#Vendor:         JPackage Project
#Distribution:   JPackage

%description
FOP is the world's first print formatter driven by XSL formatting
objects. It is a Java application that reads a formatting object tree
and then turns it into a PDF document. The formatting object tree, can
be in the form of an XML document (output by an XSLT engine like XT or
Xalan) or can be passed in memory as a DOM Document or (in the case of
XT) SAX events.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description    javadoc
Javadoc for %{name}.


%prep
%setup -q
%patch0 -p0
%patch1 -p1

# replace all binary libs
find lib -name "*.jar" -exec rm {} \;

# link libs for javadoc
ln -s $(find-jar ant) lib/ant.jar
ln -s $(find-jar avalon-framework) lib/avalon-framework.jar
ln -s $(find-jar batik/awt-util) lib/batik-awt-util.jar
ln -s $(find-jar batik/bridge) lib/batik-bridge.jar
ln -s $(find-jar batik/dom) lib/batik-dom.jar
ln -s $(find-jar batik/ext) lib/batik-ext.jar
ln -s $(find-jar batik/gvt) lib/batik-gvt.jar
ln -s $(find-jar batik/svg-dom) lib/batik-svg-dom.jar
ln -s $(find-jar batik/transcoder) lib/batik-transcoder.jar
ln -s $(find-jar batik/util) lib/batik-util.jar
# Not really required as it will fall back to jimi
#ln -s $(find-jar jai/jai_codec) lib/jai-codec.jar
#ln -s $(find-jar jai/jai_core) lib/jai-core.jar
ln -s $(find-jar jimi) lib/jimi.jar

%build
export OPT_JAR_LIST="ant/ant-trax jaxp_transform_impl"
export CLASSPATH=$(build-classpath xml-commons-apis xalan-j2 avalon-framework \
avalon-logkit batik/awt-util batik/bridge batik/css batik/dom batik/ext \
batik/gvt batik/parser batik/transcoder batik/util batik/svg-dom batik/swing \
jimi jce)

ant -d \
  -Dbuild.compiler=modern \
  -Dj2se.javadoc=%{_javadocdir}/java \
  -Dbatik.javadoc=%{_javadocdir}/batik \
  package javadocs


%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# script
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/fop

# data
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr src/hyph $RPM_BUILD_ROOT%{_datadir}/%{name}
cp -pr conf $RPM_BUILD_ROOT%{_datadir}/%{name}

# javadoc
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr build/javadocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}


%clean
rm -rf $RPM_BUILD_ROOT


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(0644,root,root,0755)
%doc CHANGES LICENSE README ReleaseNotes.html STATUS
%attr(0755,root,root) %{_bindir}/fop
%{_javadir}/%{name}*.jar
%{_datadir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}


%changelog
* Tue Nov 16 2004 Fernando Nasser <fnasser@redhat.com> - 0:0.20.5-6jpp_1rh
- Merge with upstream

* Fri Oct 1 2004 Andrew Overholt <overholt@redhat.com> - 0:0.20.5-4jpp_2rh
- add coreutils BuildRequires

* Mon Aug 23 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-6jpp
- Build with ant-1.6.2

* Fri Aug 06 2004 Ralph Apel <r.apel at r-apel.de> - 0:0.20.5-5jpp
- Void change

* Tue Jul 13 2004 Fernando Nasser <fnasser@redhat.com> - 0:0.20.5-4jpp_1rh
- Merge with upstream new version that removes dependency on ant-optional

* Tue Jun 01 2004 Randy Watler <rwatler at finali.com> - 0:0.20.5-4jpp
- Upgrade to Ant 1.6.X

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> - 0:0.20.5-3jpp_1rh
- RH vacuuming
- removed JAI references; should fall back to JIMI

* Thu Jan  8 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-3jpp
- BuildRequires ant-optional.
- Crosslink with full J2SE javadocs instead of just JAXP/XML-commons.
- Add Main-Class back to manifest.

* Tue Sep 23 2003 Paul Nasrat <pauln at truemesh.com> - 0:0.20.5-2jpp
- Fix script and requires
- Remove class path in manifest
- New javadoc style

* Sat Jul 19 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-1jpp
- Update to 0.20.5.
- Crosslink with xml-commons-apis and batik javadocs.
- BuildRequires jai, jce and jimi.

* Sat Jun  7 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-0.rc3a.1jpp
- Update to 0.20.5rc3a.
- Include fop script.
- Non-versioned javadoc symlinks.

* Thu Apr 17 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:0.20.5-0.rc2.1jpp
- Update to 0.20.5rc2 and JPackage 1.5.

* Sun Mar 10 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.20.3-1jpp
- 0.20.3 final
- fixed missing symlink

* Mon Jan 21 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.20.3-0.rc.1jpp
- 0.20.3rc
- first unified release
- javadoc into javadoc package
- no dependencies for manual package
- s/jPackage/JPackage
- adaptation to new xalan-j2 package
- requires and buildrequires avalon-logkit

* Thu Aug 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 0.20.1-1mdk
- first release
